# Copyright 2014-2020 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_prediction12_', [dirname(__file__)])
        except ImportError:
            import _prediction12_
            return _prediction12_
        if fp is not None:
            try:
                _mod = imp.load_module('_prediction12_', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _prediction12_ = swig_import_helper()
    del swig_import_helper
else:
    import _prediction12_
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import daal.algorithms.multi_class_classifier
import daal.algorithms.classifier
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.features
import daal.data_management.modifiers.csv
import daal.data_management.modifiers
import daal.algorithms.classifier.training
import daal.algorithms.classifier.prediction

_prediction12_.defaultDense_swigconstant(_prediction12_)
defaultDense = _prediction12_.defaultDense

_prediction12_.multiClassClassifierWu_swigconstant(_prediction12_)
multiClassClassifierWu = _prediction12_.multiClassClassifierWu

_prediction12_.voteBased_swigconstant(_prediction12_)
voteBased = _prediction12_.voteBased

_prediction12_.prediction_swigconstant(_prediction12_)
prediction = _prediction12_.prediction

_prediction12_.decisionFunction_swigconstant(_prediction12_)
decisionFunction = _prediction12_.decisionFunction

_prediction12_.lastResultId_swigconstant(_prediction12_)
lastResultId = _prediction12_.lastResultId
class Input(daal.algorithms.classifier.prediction.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _prediction12_.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction12_.delete_Input
    __del__ = lambda self: None

    def getTable(self, id):
        return _prediction12_.Input_getTable(self, id)

    def getModel(self, id):
        return _prediction12_.Input_getModel(self, id)

    def setTable(self, id, ptr):
        return _prediction12_.Input_setTable(self, id, ptr)

    def set(self, id, ptr):
        return _prediction12_.Input_set(self, id, ptr)

    def check(self, parameter, method):
        return _prediction12_.Input_check(self, parameter, method)
Input_swigregister = _prediction12_.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.classifier.prediction.interface2_Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.interface2_Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.interface2_Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _prediction12_.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_prediction12_.Result_serializationTag)

    def getSerializationTag(self):
        return _prediction12_.Result_getSerializationTag(self)

    def __init__(self):
        this = _prediction12_.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this

    def get(self, id):
        return _prediction12_.Result_get(self, id)

    def set(self, id, value):
        return _prediction12_.Result_set(self, id, value)

    def check(self, input, par, method):
        return _prediction12_.Result_check(self, input, par, method)
    __swig_destroy__ = _prediction12_.delete_Result
    __del__ = lambda self: None
Result_swigregister = _prediction12_.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _prediction12_.Result_serializationTag()
Result_serializationTag = _prediction12_.Result_serializationTag

class Batch_Float64VoteBasedOneAgainstOne(daal.algorithms.classifier.prediction.Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64VoteBasedOneAgainstOne, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64VoteBasedOneAgainstOne, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _prediction12_.Batch_Float64VoteBasedOneAgainstOne_input_set
    __swig_getmethods__["input"] = _prediction12_.Batch_Float64VoteBasedOneAgainstOne_input_get
    if _newclass:
        input = _swig_property(_prediction12_.Batch_Float64VoteBasedOneAgainstOne_input_get, _prediction12_.Batch_Float64VoteBasedOneAgainstOne_input_set)
    __swig_setmethods__["parameter"] = _prediction12_.Batch_Float64VoteBasedOneAgainstOne_parameter_set
    __swig_getmethods__["parameter"] = _prediction12_.Batch_Float64VoteBasedOneAgainstOne_parameter_get
    if _newclass:
        parameter = _swig_property(_prediction12_.Batch_Float64VoteBasedOneAgainstOne_parameter_get, _prediction12_.Batch_Float64VoteBasedOneAgainstOne_parameter_set)

    def __init__(self, *args):
        this = _prediction12_.new_Batch_Float64VoteBasedOneAgainstOne(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction12_.delete_Batch_Float64VoteBasedOneAgainstOne
    __del__ = lambda self: None

    def getInput(self):
        return _prediction12_.Batch_Float64VoteBasedOneAgainstOne_getInput(self)

    def getMethod(self):
        return _prediction12_.Batch_Float64VoteBasedOneAgainstOne_getMethod(self)

    def clone(self):
        return _prediction12_.Batch_Float64VoteBasedOneAgainstOne_clone(self)

    def compute(self):
        return _prediction12_.Batch_Float64VoteBasedOneAgainstOne_compute(self)
Batch_Float64VoteBasedOneAgainstOne_swigregister = _prediction12_.Batch_Float64VoteBasedOneAgainstOne_swigregister
Batch_Float64VoteBasedOneAgainstOne_swigregister(Batch_Float64VoteBasedOneAgainstOne)

class Batch_Float64MultiClassClassifierWuOneAgainstOne(daal.algorithms.classifier.prediction.Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64MultiClassClassifierWuOneAgainstOne, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64MultiClassClassifierWuOneAgainstOne, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_input_set
    __swig_getmethods__["input"] = _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_input_get
    if _newclass:
        input = _swig_property(_prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_input_get, _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_input_set)
    __swig_setmethods__["parameter"] = _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_parameter_set
    __swig_getmethods__["parameter"] = _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_parameter_get
    if _newclass:
        parameter = _swig_property(_prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_parameter_get, _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_parameter_set)

    def __init__(self, *args):
        this = _prediction12_.new_Batch_Float64MultiClassClassifierWuOneAgainstOne(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction12_.delete_Batch_Float64MultiClassClassifierWuOneAgainstOne
    __del__ = lambda self: None

    def getInput(self):
        return _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_getInput(self)

    def getMethod(self):
        return _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_getMethod(self)

    def clone(self):
        return _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_clone(self)

    def compute(self):
        return _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_compute(self)
Batch_Float64MultiClassClassifierWuOneAgainstOne_swigregister = _prediction12_.Batch_Float64MultiClassClassifierWuOneAgainstOne_swigregister
Batch_Float64MultiClassClassifierWuOneAgainstOne_swigregister(Batch_Float64MultiClassClassifierWuOneAgainstOne)

class Batch_Float32VoteBasedOneAgainstOne(daal.algorithms.classifier.prediction.Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32VoteBasedOneAgainstOne, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32VoteBasedOneAgainstOne, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _prediction12_.Batch_Float32VoteBasedOneAgainstOne_input_set
    __swig_getmethods__["input"] = _prediction12_.Batch_Float32VoteBasedOneAgainstOne_input_get
    if _newclass:
        input = _swig_property(_prediction12_.Batch_Float32VoteBasedOneAgainstOne_input_get, _prediction12_.Batch_Float32VoteBasedOneAgainstOne_input_set)
    __swig_setmethods__["parameter"] = _prediction12_.Batch_Float32VoteBasedOneAgainstOne_parameter_set
    __swig_getmethods__["parameter"] = _prediction12_.Batch_Float32VoteBasedOneAgainstOne_parameter_get
    if _newclass:
        parameter = _swig_property(_prediction12_.Batch_Float32VoteBasedOneAgainstOne_parameter_get, _prediction12_.Batch_Float32VoteBasedOneAgainstOne_parameter_set)

    def __init__(self, *args):
        this = _prediction12_.new_Batch_Float32VoteBasedOneAgainstOne(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction12_.delete_Batch_Float32VoteBasedOneAgainstOne
    __del__ = lambda self: None

    def getInput(self):
        return _prediction12_.Batch_Float32VoteBasedOneAgainstOne_getInput(self)

    def getMethod(self):
        return _prediction12_.Batch_Float32VoteBasedOneAgainstOne_getMethod(self)

    def clone(self):
        return _prediction12_.Batch_Float32VoteBasedOneAgainstOne_clone(self)

    def compute(self):
        return _prediction12_.Batch_Float32VoteBasedOneAgainstOne_compute(self)
Batch_Float32VoteBasedOneAgainstOne_swigregister = _prediction12_.Batch_Float32VoteBasedOneAgainstOne_swigregister
Batch_Float32VoteBasedOneAgainstOne_swigregister(Batch_Float32VoteBasedOneAgainstOne)

class Batch_Float32MultiClassClassifierWuOneAgainstOne(daal.algorithms.classifier.prediction.Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32MultiClassClassifierWuOneAgainstOne, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.classifier.prediction.Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32MultiClassClassifierWuOneAgainstOne, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_input_set
    __swig_getmethods__["input"] = _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_input_get
    if _newclass:
        input = _swig_property(_prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_input_get, _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_input_set)
    __swig_setmethods__["parameter"] = _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_parameter_set
    __swig_getmethods__["parameter"] = _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_parameter_get
    if _newclass:
        parameter = _swig_property(_prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_parameter_get, _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_parameter_set)

    def __init__(self, *args):
        this = _prediction12_.new_Batch_Float32MultiClassClassifierWuOneAgainstOne(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction12_.delete_Batch_Float32MultiClassClassifierWuOneAgainstOne
    __del__ = lambda self: None

    def getInput(self):
        return _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_getInput(self)

    def getMethod(self):
        return _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_getMethod(self)

    def clone(self):
        return _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_clone(self)

    def compute(self):
        return _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_compute(self)
Batch_Float32MultiClassClassifierWuOneAgainstOne_swigregister = _prediction12_.Batch_Float32MultiClassClassifierWuOneAgainstOne_swigregister
Batch_Float32MultiClassClassifierWuOneAgainstOne_swigregister(Batch_Float32MultiClassClassifierWuOneAgainstOne)

from daal.algorithms.multi_class_classifier.training import oneAgainstOne

from numpy import float64, float32, intc

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'pmethod' in kwargs and kwargs['pmethod'] == voteBased:
                    if 'tmethod' not in kwargs or kwargs['tmethod'] == daal.algorithms.multi_class_classifier.training.oneAgainstOne:
                        return Batch_Float64VoteBasedOneAgainstOne(*args)
            if 'pmethod' not in kwargs or kwargs['pmethod'] == multiClassClassifierWu:
                    if 'tmethod' not in kwargs or kwargs['tmethod'] == daal.algorithms.multi_class_classifier.training.oneAgainstOne:
                        return Batch_Float64MultiClassClassifierWuOneAgainstOne(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'pmethod' in kwargs and kwargs['pmethod'] == voteBased:
                    if 'tmethod' not in kwargs or kwargs['tmethod'] == daal.algorithms.multi_class_classifier.training.oneAgainstOne:
                        return Batch_Float32VoteBasedOneAgainstOne(*args)
            if 'pmethod' not in kwargs or kwargs['pmethod'] == multiClassClassifierWu:
                    if 'tmethod' not in kwargs or kwargs['tmethod'] == daal.algorithms.multi_class_classifier.training.oneAgainstOne:
                        return Batch_Float32MultiClassClassifierWuOneAgainstOne(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


